// Smiler.cpp: CSmiler NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "textsmile.h"
#include "Smiler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSmiler::CSmiler()
{

}

CSmiler::~CSmiler()
{

}

void CSmiler::WriteToReg()
{
	int HTML = 0,CPP = 0,CRLF = 0;
	if( m_bHTML )	HTML = 1;
	if( m_bCPP )	CPP = 1;
	if( m_bCRLF )	CRLF = 1;

	AfxGetApp()->WriteProfileString( _T("Settings"),_T("modeFilePath"),m_FileName );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("frequency"),m_Frq );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("HTMLCut"),HTML );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("CPPCut"),CPP );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("ReturnCode"),CRLF );

	AfxGetApp()->WriteProfileString( _T("Settings"),_T("Hankaku"),m_Han );
	AfxGetApp()->WriteProfileString( _T("Settings"),_T("Zenkaku"),m_Zen );
}

void CSmiler::LoadFromReg()
{
	m_FileName = AfxGetApp()->GetProfileString( _T("Settings"),_T("modeFilePath"),_T("????") );
	m_Frq = AfxGetApp()->GetProfileInt( _T("Settings"),_T("frequency"),80 );
	m_bHTML = ( 0!=AfxGetApp()->GetProfileInt( _T("Settings"),_T("HTMLCut"),0 ) );
	m_bCPP = ( 0!=AfxGetApp()->GetProfileInt( _T("Settings"),_T("CPPCut"),0 ) );
	m_bCRLF = ( 0!=AfxGetApp()->GetProfileInt( _T("Settings"),_T("ReturnCode"),1 ) );

	m_Han = AfxGetApp()->GetProfileString( _T("Settings"),_T("Hankaku"),_T("*") );
	m_Zen = AfxGetApp()->GetProfileString( _T("Settings"),_T("Zenkaku"),_T("") );

	Load(m_FileName);
}

bool CSmiler::Load(CString & filename)
{
	m_Map.RemoveAll();
	m_Name = "q";
	m_Separator = " ";

	if( 0==strcmp(filename,"????") )
	{
		DefaultSet();
		return true;
	}

	CStdioFile file;
	if( !file.Open( filename,CFile::modeRead | CFile::typeText ) )
		return false;
	m_FileName = filename;

	for( int i=1;;i++ )
	{
		CString lineStr;
		if( !file.ReadString(lineStr) )
			break;
		if( !LineRead(lineStr) )
		{
			Error(i);
			DefaultSet();
			return false;
		}
	}
	return true;
}

bool CSmiler::LineRead(CString & str)
{
	if( str.IsEmpty() )
		return true;

	CString past;
	CString future;
	char cmd;

	// RgȂƂ΂
	if( str[0]=='c' )	return true;
	// R}h擾
	int s = str.Find(m_Separator);
	if(s != 1)	return false;
	cmd = str.GetAt(0);

	// future and past 擾
	str = str.Right( str.GetLength() - 1 - m_Separator.GetLength() );
	s = str.Find(m_Separator);
	if( s==0 )	return false;
	if( s==-1 )
	{
		past = str;
		future.Empty();
	}
	else
	{
		past = str.Left( s );
		future = str.Right( str.GetLength() - (s + m_Separator.GetLength() ) );
	}

	// 
	bool bOfs = false;

	switch( cmd )
	{
	case'n':
		m_Name = past;
		return true;
	case's':
		m_Separator = past;
		return true;

	case'w':
		Set(future,past);
		break;

	case'r':
		break;
	case'b':
		future = future + past;
		break;
	case'a':
		future = past + future;
		break;
	case'd':
		future.Empty();
		break;

	default:
		return false;
	}

	Set(past,future);
	return true;
}

void CSmiler::Error(int num)
{
	CString str;
	str.Format("%dsœǂݍ݃G[N܂B",num);
	AfxMessageBox( str );
}

#define _MBCS

bool CSmiler::AddEffect(CString & str, int max,CProgDialog* pDlg)
{
	pDlg->SetString("΂łŒŌB");

	int allLn = max;
	int strLn = str.GetLength();
	LPTSTR pStr;

	try
	{
		pStr = str.GetBufferSetLength( allLn );
	}
	catch( CMemoryException* pMem )
	{
		pMem = pMem;
		AfxMessageBox("ɊւO܂BςłBi΁j");
		throw;
	}

	int i=0;
	while( i<=strLn )
	{
		pDlg->SetVal(100*i/strLn);
		// mvZ
		if( rand()%100 >= m_Frq )
		{
			//2byteȂQAȊOȂPi߂
			if( _ismbblead( (UINT)pStr[i] ) )
				i++;
			i++;
			continue;
		}
		// ꕶڔ
		CList<CSmileElement*,CSmileElement*>* pList;
		if( !m_Map.Lookup( pStr[i] , pList ) )
		{
			//2byteȂQAȊOȂPi߂
			if( _ismbblead( (UINT)pStr[i] ) )
				i++;
			i++;
			continue;
		}

		// K؂ȃX}C擾
		POSITION Pos = pList->GetHeadPosition();
		int j = 1;
		CSmileElement* pEle = NULL;
		while( Pos!=0 )
		{
			// ߋ玟̉ߋB
			if( i + pList->GetAt(Pos)->m_Past.GetLength()/2 > strLn )
			{
				pList->GetNext(Pos);
				continue;
			}

			// ߋƌ݂r
			if( pList->GetAt(Pos)->MatchToPast(&pStr[i]) )
			{
				if( rand()%j==0 )// Ɍ̂D悳Ȃ悤ɊmU蕪B
					pEle = pList->GetAt(Pos);
				j++;
			}
			pList->GetNext(Pos);
		}
		// K؂ȃX}CȂ玟̕
		if( pEle==NULL )
		{
			//2byteȂQAȊOȂPi߂
			if( _ismbblead( (UINT)pStr[i] ) )
				i++;
			i++;
			continue;
		}


		// TCYI[o[Ȃd
		if( strLn + pEle->GetFutureLen() - pEle->GetPastLen() > allLn )
		{
			str.ReleaseBuffer( -1 );
			return false;
		}

		// ܂
		memmove( &pStr[i+pEle->GetFutureLen()] , &pStr[i+pEle->GetPastLen()] , strLn-(i+pEle->GetPastLen())+1 );
		// 󂢂ɃZbg
		memcpy( &pStr[i] , pEle->GetFuture() , pEle->GetFutureLen() );

		// pf[^ݒ
		DWORD a = ((pEle->GetFutureLen())<<16) + (i);
		m_ChangeIndex.Add( a );
		// i߂
		strLn += pEle->GetFutureLen() - pEle->GetPastLen();
		i += pEle->GetFutureLen();
	}

	// ɖ߂B
	str.ReleaseBuffer( -1 );

	return true;
}
#undef _MBCS

void CSmiler::DefaultSet()
{
	m_Name = "ςʏΊ";

	Set( "܂B","܂B" );
	Set( "łB","ł͂܂B" );
	Set( "B","ˁH" );
	Set( "B","i΁jB" );
	Set( "B","Aف[B" );
	Set( "B","......B" );
	Set( "A","i܁jA" );
	Set( "A","ˁA" );
	Set( "A","AȂ" );
	Set( "A","(^_^;)A" );
	Set( "Ȃ̂ŁA","Ƃ͉̂RȂ̂ŁA" );
}

void CSmiler::Set(CString p, CString f)
{
	CSmileElement* pSml = new CSmileElement;
	pSml->SetUp(p,f);

	CList<CSmileElement*,CSmileElement*>* pList;
	if( m_Map.Lookup( pSml->m_Past.GetAt(0) , pList ) )
	{
		pList->AddTail(pSml);
	}
	else
	{
		pList = new CList<CSmileElement*,CSmileElement*>;
		pList->AddTail(pSml);
		m_Map.SetAt( pSml->m_Past.GetAt(0),pList );
	}
}

void CSmiler::ClearChangeIndex()
{
	m_ChangeIndex.RemoveAll();
}

DWORD CSmiler::GetChangeIndexAfter(DWORD num)
{
	for( int i=0; i!=m_ChangeIndex.GetSize(); i++ )
	{
		if( (m_ChangeIndex[i]&0xffff) > num )
			return m_ChangeIndex[i];
	}

	AfxMessageBox("ɂ͂ȂB");
	return -1;
}

DWORD CSmiler::GetChangeIndexBefore(DWORD num)
{
	for( int i=m_ChangeIndex.GetSize()-1; i!=-1; i-- )
	{
		if( (m_ChangeIndex[i]&0xffff) < num )
			return m_ChangeIndex[i];
	}

	AfxMessageBox("Oɂ͂ȂB");
	return -1;
}

void CSmiler::CopyChangeIndex(CSmiler & From)
{
	m_ChangeIndex.Copy( From.m_ChangeIndex );
}

bool CSmiler::HideChange(CString& str)
{
#define _MBCS

	if( m_Zen.GetLength()!=2 )
		m_Zen = "";
	if( m_Han.GetLength()!=1 )
		m_Han = "*";

	srand(time(NULL));

	int i,length = str.GetLength();
	for( i=0; i!=length; i++ )
	{
		if( str[i] == '\n' || str[i] == '\r' || str[i] == ' ' || str[i] == '\t' )
			continue;

		if( _ismbblead( (UINT)str[i] ) )
		{
			if( rand()%100 <= m_Frq && str.Mid( i,2 ) != "@" )
			{
				str.SetAt( i , m_Zen[0] );
				str.SetAt( i+1 , m_Zen[1] );
			}
			i++;
			continue;
		}

		if( rand()%100 <= m_Frq )
			str.SetAt( i , m_Han[0] );
	}
#undef _MBCS
	return true;
}

bool CSmiler::RandDelChange(CString& str)
{
#define _MBCS

	srand(time(NULL));

	int strLn = str.GetLength();
	LPTSTR pStr;

	pStr = str.GetBufferSetLength( strLn );

	for( int i=0; i!=strLn; i++ )
	{
		if( pStr[i] == '\n' || pStr[i] == '\r' || pStr[i] == ' ' || pStr[i] == '\t' )
			continue;

		if( _ismbblead( (UINT)pStr[i] ) )
		{
			if( rand()%100 <= m_Frq )
			{
				memmove( &pStr[i] , &pStr[i+2] , strLn-i-1 );
				strLn-=2;
				i--;
			}
			else
				i++;
			continue;
		}

		if( rand()%100 <= m_Frq )
		{
			memmove( &pStr[i] , &pStr[i+1] , strLn-i );
			strLn--;
			i--;
		}
	}
#undef _MBCS
	return true;
}

bool CSmiler::ReverseChange(CString& str)
{
	str.MakeReverse();

	CString complete;

	while(1)
	{
		int num = str.Find("\n\r");
		if( num==-1 )
		{
			complete += str;
			break;
		}
		complete += str.Left(num) + "\r\n";
		str = str.Right( str.GetLength() - num - 2 );
	}

	str = complete;

	return true;
}

/////////// static functions //////////////////////////////////////

bool CSmiler::HTMLFilter(CString & str, int max,CProgDialog* pDlg)
{
	pDlg->SetString("gslkŌB");

	int strLn = str.GetLength();
	LPTSTR pStr;

	pStr = str.GetBufferSetLength( max );

	for( int i=0; i!=strLn; i++ )
	{
		pDlg->SetVal(i*100/strLn);

		onemore:
		if( pStr[i]=='<' )
		{
			for( int j=i; j!=strLn; j++ )
			{
				if( pStr[j]=='>' )
				{
					memmove( &pStr[i] , &pStr[j+1] , strLn-j+1 );
					strLn -= (j-i);
					goto onemore;
				}
			}
		}

		if( pStr[i]=='&' && pStr[i+1]=='l' && pStr[i+2]=='t' && pStr[i+3]==';' )
		{
			memmove( &pStr[i+1] , &pStr[i+4] , strLn-i-3 );
			pStr[i] = '<';
			strLn -= 3;
		}
		if( pStr[i]=='&' && pStr[i+1]=='g' && pStr[i+2]=='t' && pStr[i+3]==';' )
		{
			memmove( &pStr[i+1] , &pStr[i+4] , strLn-i-3 );
			pStr[i] = '>';
			strLn -= 3;
		}
		if( pStr[i]=='&' && pStr[i+1]=='q' && pStr[i+2]=='u' && pStr[i+3]=='o' && pStr[i+4]=='t' && pStr[i+5]==';')
		{
			memmove( &pStr[i+1] , &pStr[i+6] , strLn-i-5 );
			pStr[i] = '\"';
			strLn -= 5;
		}
		if( pStr[i]=='&' && pStr[i+1]=='a' && pStr[i+2]=='m' && pStr[i+3]=='p' && pStr[i+4]==';')
		{
			memmove( &pStr[i+1] , &pStr[i+5] , strLn-i-4 );
			pStr[i] = '&';
			strLn -= 4;
		}

		if( strLn>max )
			break;
	}

	str.ReleaseBuffer( -1 );
	return true;
}

bool CSmiler::CPPFilter(CString & str, int max,CProgDialog* pDlg)
{
	pDlg->SetString("bCb{{RgŌB");

	int strLn = str.GetLength();
	LPTSTR pStr;

	pStr = str.GetBufferSetLength( strLn+2 );

	for( int i=0; i<strLn-1; i++ )
	{
		pDlg->SetVal(i*100/strLn);

		_onemore:
		if( pStr[i]=='/' && pStr[i+1]=='*' )
		{
			for( int j=i+2; j<strLn-1; j++ )
			{
				if( pStr[j]=='*' && pStr[j+1]=='/' )
				{
					memmove( &pStr[i] , &pStr[j+2] , strLn-(j+2)+1 );
					strLn -= (j+2-i);
					goto _onemore;
				}
			}
		}

		__onemore:
		if( pStr[i]=='/' && pStr[i+1]=='/' )
		{
			for( int j=i+2; j<strLn-1; j++ )
			{
				if( pStr[j]=='\r' && pStr[j+1]=='\n' )
				{
					memmove( &pStr[i] , &pStr[j] , strLn-j+1 );
					strLn -= (j-i);
					goto __onemore;
				}
			}
		}
	}

	str.ReleaseBuffer( -1 );
	return true;
}

bool CSmiler::CRLFFilter(CString & str, int max,CProgDialog* pDlg)
{
	pDlg->SetString("sR[hŌB");

	int strLn = str.GetLength();
	LPTSTR pStr;

	pStr = str.GetBufferSetLength( max );

	for( int i=0; i!=strLn; i++ )
	{
		if( strLn == max )
			break;

		pDlg->SetVal(i*100/strLn);

		if( pStr[i]=='\r' && ( pStr[i+1]!='\n' || i==strLn-1 ) )
		{
			memmove( &pStr[i+2] , &pStr[i+1] , strLn-i );
			pStr[i+1] = '\n';
			strLn++;
			i++;
		}
		else if( pStr[i]=='\n' && ( pStr[i-1]!='\r' || i==0 ) )
		{
			memmove( &pStr[i+1] , &pStr[i] , strLn-i+1 );
			pStr[i] = '\r';
			strLn++;
			i++;
		}
	}

	str.ReleaseBuffer( -1 );
	return true;
}


bool CSmiler::T2HFilter(CString & str, int max,CProgDialog* pDlg)
{
	pDlg->SetString("gslkɕϊŌB");

	max*=3;

	int strLn = str.GetLength();
	LPTSTR pStr;

	pStr = str.GetBufferSetLength( max );

	int i=0;


	char* pHeader="<html>\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=x-sjis\">\n<title>Untitled</title>\n</head>\r\n<body>\n<pre>\n";
	char* pEnd="\n</pre>\n</body>\n</head>\n";

	memmove( pStr + strlen(pHeader) , pStr , strLn );
	memcpy( pStr , pHeader , strlen(pHeader) );
	strLn += strlen(pHeader);
	i += strlen(pHeader);


	for( ; i!=strLn; i++ )
	{
		if( strLn == max )
			break;

		pDlg->SetVal(i*100/strLn);

		if( pStr[i]=='<' )
		{
			memmove( &pStr[i+3] , &pStr[i] , strLn-i );
			pStr[i] = '&';
			pStr[i+1] = 'l';
			pStr[i+2] = 't';
			pStr[i+3] = ';';
			strLn+=3;
			i+=3;
		}
		else if( pStr[i]=='>' )
		{
			memmove( &pStr[i+3] , &pStr[i] , strLn-i );
			pStr[i] = '&';
			pStr[i+1] = 'g';
			pStr[i+2] = 't';
			pStr[i+3] = ';';
			strLn+=3;
			i+=3;
		}
		else if( pStr[i]=='&' )
		{
			memmove( &pStr[i+4] , &pStr[i] , strLn-i );
			pStr[i] = '&';
			pStr[i+1] = 'a';
			pStr[i+2] = 'm';
			pStr[i+3] = 'p';
			pStr[i+4] = ';';
			strLn+=4;
			i+=4;
		}
		else if( pStr[i]=='\"' )
		{
			memmove( &pStr[i+5] , &pStr[i] , strLn-i );
			pStr[i] = '&';
			pStr[i+1] = 'q';
			pStr[i+2] = 'u';
			pStr[i+3] = 'o';
			pStr[i+4] = 't';
			pStr[i+5] = ';';
			strLn+=5;
			i+=5;
		}
		else if( pStr[i]=='\r' && pStr[i+1]=='\n' )
		{
			memmove( &pStr[i] , &pStr[i+1] , strLn-i );
			strLn--;
		}
	}

	memcpy( &pStr[strLn] , pEnd , strlen(pEnd) );
	strLn += strlen(pEnd);
	pStr[strLn]='\0';

	str.ReleaseBuffer( -1 );
	return true;
}

