// TextSmileDoc.cpp : CTextSmileDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "TextSmile.h"

#include "TextSmileDoc.h"

#include "TextSmileView.h"
#include "SmileBox.h"
#include "ProgDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextSmileDoc

IMPLEMENT_DYNCREATE(CTextSmileDoc, CDocument)

BEGIN_MESSAGE_MAP(CTextSmileDoc, CDocument)
	//{{AFX_MSG_MAP(CTextSmileDoc)
	ON_COMMAND(ID_CONVERT_SETTING, OnConvertSetting)
	ON_COMMAND(ID_FILE_REOPEN, OnFileReopen)
	ON_COMMAND(ID_SMILE_RESMILE, OnSmileResmile)
	ON_COMMAND(ID_SMILE_OTHERSMILE, OnSmileOthersmile)
	ON_COMMAND(ID_FIND_SMLFINDNEXT, OnFindSmlfindnext)
	ON_COMMAND(ID_FIND_SMLFINDPREV, OnFindSmlfindprev)
	ON_COMMAND(ID_EFFECT_HIDE, OnEffectHide)
	ON_COMMAND(ID_EFFECT_REVERSE, OnEffectReverse)
	ON_COMMAND(ID_EFFECT_RANDOMDEL, OnEffectRandomDel)
	ON_UPDATE_COMMAND_UI(ID_EFFECT_HIDE, OnUpdateEffect)
	ON_UPDATE_COMMAND_UI(ID_EFFECT_REVERSE, OnUpdateEffect)
	ON_UPDATE_COMMAND_UI(ID_EFFECT_RANDOMDEL, OnUpdateEffect)
	ON_COMMAND(ID_EDIT_MYUNDO, OnEditUndo)
	ON_COMMAND(ID_FILE_HTMLOUT, OnHtmlout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextSmileDoc NX̍\z/

CTextSmileDoc::CTextSmileDoc()
{
	CString CurDir = AfxGetApp()->GetProfileString(_T("Settings"),_T("CurrentDirectory"),_T("noSet"));
	if( CurDir!="noSet" )
		SetCurrentDirectory(CurDir);

	m_Smiler.LoadFromReg();

	m_bInit = false;
	m_bUndoAble = false;
}

CTextSmileDoc::~CTextSmileDoc()
{
	m_Smiler.WriteToReg();
}

/////////////////////////////////////////////////////////////////////////////
// CTextSmileDoc VAC[[V

void CTextSmileDoc::Serialize(CArchive& ar)
{
	// CEditView ׂ͂ẴVAC[[V nĥǂꂩ̃GfBbgRg[܂ł܂B
	((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CTextSmileDoc NX̐ff

#ifdef _DEBUG
void CTextSmileDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTextSmileDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTextSmileDoc R}h

void CTextSmileDoc::OnConvertSetting() 
{
	CSmileBox dlg;
	CString prev = m_Smiler.m_FileName;

	dlg.m_pSml = &m_Smiler;
	dlg.m_Frq = m_Smiler.m_Frq;
	dlg.m_bHTML = m_Smiler.m_bHTML;
	dlg.m_bCPP = m_Smiler.m_bCPP;
	dlg.m_bCRLF = m_Smiler.m_bCRLF;

	dlg.m_ZenkakuHide = m_Smiler.m_Zen;
	dlg.m_HankakuHide = m_Smiler.m_Han;

	if( IDOK==dlg.DoModal() )
	{
		m_Smiler.m_Frq = dlg.m_Frq;
		m_Smiler.m_bHTML = ( 0!=dlg.m_bHTML );
		m_Smiler.m_bCPP = ( 0!=dlg.m_bCPP );
		m_Smiler.m_bCRLF = ( 0!=dlg.m_bCRLF );

		m_Smiler.m_Zen = dlg.m_ZenkakuHide;
		m_Smiler.m_Han = dlg.m_HankakuHide;

		if( !GetPathName().IsEmpty() )
		{
			if( IDYES == AfxMessageBox("ݒ肪ύXꂽ܂Bt@Că[h܂H",MB_YESNO) )
			{
				CString str=GetPathName();
				if( !str.IsEmpty() )
					OnOpenDocument( str );
			}
		}
	}
	else
	{
		if( !m_Smiler.Load( prev ) )
		{
			AfxMessageBox("LZɃG[܂B");
			m_Smiler.DefaultSet();
		}
	}
}

void CTextSmileDoc::OnFileReopen() 
{
	CString str=GetPathName();
	if( !str.IsEmpty() )
		OnOpenDocument( str );
}

BOOL CTextSmileDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	if( m_bInit )
		Smile(&m_Smiler);

	m_bUndoAble = false;
	return TRUE;
}

bool CTextSmileDoc::Smile( CSmiler* pSml )
{
	CProgDialog pd;
	srand(time(NULL));

	pd.SetString("eLXg擾ŌB");
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();
	CString str;
	edit.GetWindowText( str );

	m_StrBack = str;
	m_CngBack.CopyChangeIndex(m_Smiler);
	m_bUndoAble = true;
	m_Smiler.ClearChangeIndex();

	if( m_Smiler.m_bHTML )	CSmiler::HTMLFilter(str,edit.GetLimitText(),&pd);
	if( m_Smiler.m_bCPP )	CSmiler::CPPFilter(str,edit.GetLimitText(),&pd);
	if( m_Smiler.m_bCRLF )	CSmiler::CRLFFilter(str,edit.GetLimitText(),&pd);

	if( !pSml->AddEffect( str , edit.GetLimitText()/2 , &pd ) )
	{
		AfxMessageBox("̒E𒴂܂B̕ϊ͖łB");
		m_Smiler.CopyChangeIndex(m_CngBack);
		m_bUndoAble = false;
		return false;
	}

	pd.SetString("eLXgݒ蒆ŌB");
	edit.SetWindowText( str );

	if( pSml != &m_Smiler )
		m_Smiler.CopyChangeIndex(*pSml);

	vw->FitWindow();
	return true;
}

void CTextSmileDoc::OnSmileResmile() 
{
	Smile(&m_Smiler);
}

void CTextSmileDoc::OnSmileOthersmile() 
{
	CString filter = "X}Ct@C(*.sml)|*.sml|SẴt@C(*.*)|*.*||";
	CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,filter);
	dlg.m_ofn.lpstrTitle = "u΂ݕvIłB";
	if( dlg.DoModal()!=IDOK )	return;

	CSmiler tmpMode;
	if( !tmpMode.Load( dlg.GetPathName() ) )
	{
		AfxMessageBox("ݒt@C̃[hɎs܂B");
		return;
	}

	Smile( &tmpMode );
}


void CTextSmileDoc::OnFindSmlfindnext() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();

	int Cursor = ( edit.GetSel() & 0xffff );

	if( -1 == (Cursor = m_Smiler.GetChangeIndexAfter(Cursor)) )
		return;
	edit.SetSel( Cursor&0xffff , (Cursor&0xffff) + (Cursor>>16) );
}

void CTextSmileDoc::OnFindSmlfindprev() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();

	int Cursor = ( edit.GetSel() & 0xffff );

	if( -1 == (Cursor = m_Smiler.GetChangeIndexBefore(Cursor)) )
		return;
	edit.SetSel( Cursor&0xffff , (Cursor&0xffff) + (Cursor>>16) );
}

void CTextSmileDoc::OnEffectHide() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();
	// 擾
	CString str;
	int start,end;
	edit.GetWindowText( str );

	m_StrBack = str;
	m_CngBack.CopyChangeIndex(m_Smiler);
	m_bUndoAble = true;

	edit.GetSel(start,end);
	str = str.Mid(start , end-start);

	m_Smiler.HideChange(str);

	edit.ReplaceSel(str,FALSE);
	SetModifiedFlag( FALSE );

	vw->FitWindow();
}

void CTextSmileDoc::OnEffectReverse() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();
	// 擾
	CString str;
	int start,end;
	edit.GetWindowText( str );

	m_StrBack = str;
	m_CngBack.CopyChangeIndex(m_Smiler);
	m_bUndoAble = true;

	edit.GetSel(start,end);
	str = str.Mid(start , end-start);

	m_Smiler.ReverseChange(str);

	edit.ReplaceSel(str,FALSE);
	SetModifiedFlag( FALSE );

	vw->FitWindow();
}

void CTextSmileDoc::OnEffectRandomDel() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	CEdit& edit = vw->GetEditCtrl();
	// 擾
	CString str;
	int start,end;
	edit.GetWindowText( str );

	m_StrBack = str;
	m_CngBack.CopyChangeIndex(m_Smiler);
	m_bUndoAble = true;

	edit.GetSel(start,end);
	str = str.Mid(start , end-start);

	m_Smiler.RandDelChange(str);

	edit.ReplaceSel(str,FALSE);
	SetModifiedFlag( FALSE );

	vw->FitWindow();
}

void CTextSmileDoc::OnUpdateEffect(CCmdUI* pCmdUI) 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	int start,end;
	vw->GetEditCtrl().GetSel(start,end);
	pCmdUI->Enable( end-start!=0 );
}

void CTextSmileDoc::OnEditUndo() 
{
	CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
	vw->GetEditCtrl().SetWindowText(m_StrBack);
	m_Smiler.CopyChangeIndex(m_CngBack);

	vw->FitWindow();

	m_bUndoAble = false;
}

void CTextSmileDoc::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_bUndoAble );
}

void CTextSmileDoc::OnHtmlout()
{
	CString filter = "gslkt@C(*.htm)(*.html)|*.htm;*.html|SẴt@C(*.*)|*.*||";
	CFileDialog dlg(FALSE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,filter);
	dlg.m_ofn.lpstrTitle = "gslk`ŕۑ";

	if( dlg.DoModal()==IDOK )
	{
		CString fname=dlg.GetPathName();

		CProgDialog pd;
		pd.SetString("eLXg擾ŌB");
		CTextSmileView* vw = (CTextSmileView*)(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
		CEdit& edit = vw->GetEditCtrl();
		CString str;
		edit.GetWindowText( str );

		if( !CSmiler::T2HFilter(str,edit.GetLimitText(),&pd) )
		{
			AfxMessageBox("̒E𒴂܂B̕ϊ͖łB");
			return;
		}

		if( -1==fname.Find('.',0) )
			fname+=".htm";
		CStdioFile f(fname,CFile::modeWrite|CFile::typeText|CFile::modeCreate);
		f.WriteString(str);
	}
}
