// TextSmileView.cpp : CTextSmileView NX̓̒`s܂B
//

#include "stdafx.h"
#include "TextSmile.h"

#include "TextSmileDoc.h"
#include "TextSmileView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView

IMPLEMENT_DYNCREATE(CTextSmileView, CEditView)

BEGIN_MESSAGE_MAP(CTextSmileView, CEditView)
	//{{AFX_MSG_MAP(CTextSmileView)
	ON_COMMAND(ID_APP_HELP, OnAppHelp)
	ON_WM_CTLCOLOR_REFLECT()
	ON_COMMAND(ID_VIEW_BACKCOLOR, OnViewBackcolor)
	ON_COMMAND(ID_VIEW_FONT, OnViewFont)
	ON_COMMAND(ID_VIEW_AUTORESIZE, OnViewAutoresize)
	ON_UPDATE_COMMAND_UI(ID_VIEW_AUTORESIZE, OnUpdateViewAutoresize)
	ON_WM_DROPFILES()
	ON_COMMAND(ID_TS_MINIMIZE, OnMinimize)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView NX̍\z/

CTextSmileView::CTextSmileView()
{
	CString FontName = AfxGetApp()->GetProfileString( _T("Settings"),_T("Font"),_T("FixedSys") );
	m_FontSize = AfxGetApp()->GetProfileInt( _T("Settings"),_T("FontSize"),140 );
	m_Font.CreatePointFont( m_FontSize , FontName , NULL );

	m_BackColor = AfxGetApp()->GetProfileInt( _T("Settings"),_T("BackColor"),RGB(180,180,180) );
	m_TextColor = AfxGetApp()->GetProfileInt( _T("Settings"),_T("TextColor"),RGB(0,0,0) );
	m_Brush.CreateSolidBrush(m_BackColor);

	m_bAutoRS = ( 0!=AfxGetApp()->GetProfileInt( _T("Settings"),_T("AutoResize"),1 ) );
}

CTextSmileView::~CTextSmileView()
{
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("TextColor"),m_TextColor );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("BackColor"),m_BackColor );

	LOGFONT lft;
	m_Font.GetLogFont( &lft );
	CString FontName = lft.lfFaceName;
	AfxGetApp()->WriteProfileString( _T("Settings"),_T("Font"),FontName );
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("FontSize"),m_FontSize );

	int RS = 0;
	if( m_bAutoRS )	RS = 1;
	AfxGetApp()->WriteProfileInt( _T("Settings"),_T("AutoResize"),RS );
}

BOOL CTextSmileView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// [h bvgp\ɂ܂

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView NX̕`

void CTextSmileView::OnDraw(CDC* pDC)
{
	CTextSmileDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView NẌ

BOOL CTextSmileView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg CEditView ̈
	return CEditView::OnPreparePrinting(pInfo);
}

void CTextSmileView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CEditView ňJn܂B
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CTextSmileView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// ftHg CEditView ̈̌㏈
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView NX̐ff

#ifdef _DEBUG
void CTextSmileView::AssertValid() const
{
	CEditView::AssertValid();
}

void CTextSmileView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CTextSmileDoc* CTextSmileView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTextSmileDoc)));
	return (CTextSmileDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTextSmileView NX̃bZ[W nh

void CTextSmileView::OnAppHelp() 
{
	AfxGetApp()->WinHelp(0,HELP_FINDER);
}

HBRUSH CTextSmileView::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	pDC->SetBkMode(OPAQUE);
	pDC->SetBkColor(m_BackColor);
	pDC->SetTextColor(m_TextColor);
	return (HBRUSH)m_Brush;
}

void CTextSmileView::OnViewBackcolor() 
{
	CColorDialog dlg(m_BackColor,CC_FULLOPEN);

	if( IDOK==dlg.DoModal() )
	{
		m_BackColor = dlg.GetColor();
		m_Brush.DeleteObject();
		m_Brush.CreateSolidBrush(m_BackColor);
		InvalidateRect(NULL);
	}
}

void CTextSmileView::OnViewFont() 
{
	LOGFONT cur;
	m_Font.GetLogFont( &cur );
	CFontDialog dlg( &cur );
	dlg.m_cf.rgbColors = m_TextColor;

	if( IDOK==dlg.DoModal() )
	{
		LOGFONT lft;
		dlg.GetCurrentFont( &lft );

		m_Font.DeleteObject();
		m_FontSize = lft.lfHeight = dlg.GetSize();

		m_Font.CreatePointFontIndirect( &lft );
		GetEditCtrl().SetFont(&m_Font,TRUE);

		m_TextColor = dlg.GetColor();
		FitWindow();
	}
}

void CTextSmileView::FitWindow()
{
	if( !m_bAutoRS )
		return;

	CString str;
	GetEditCtrl().GetWindowText( str );

	if( str.GetLength()==0 )
		return;

	CDC* pDC = GetDC();
	CFont* pF = pDC->SelectObject( &m_Font );
	int max = 0;
	while(1)
	{
		int num = str.Find("\r\n");
		if( num==-1 )
		{
			CSize s = pDC->GetOutputTabbedTextExtent( str,0,NULL );
			if( max < s.cx + m_FontSize/10 )
				max = s.cx + m_FontSize/10;
			break;
		}
		else
		{
			CSize s = pDC->GetOutputTabbedTextExtent( str.Left(num+2),0,NULL );
			if( max < s.cx )
				max = s.cx;
			str = str.Right( str.GetLength() - num - 2 );
		}
	}
	int Req = max + m_FontSize/10;
	pDC->SelectObject( pF );
	ReleaseDC(pDC);
	
	// EChETCYύX
	RECT wr,cr,mr;
	GetParent()->GetWindowRect(&wr);
	GetWindowRect(&cr);

	if( Req < 350 )
		Req=350;

	mr.left = wr.left;
	mr.top = wr.top;
	mr.bottom = mr.top  + Req/2 + ( wr.bottom - wr.top ) - ( cr.bottom - cr.top );
	mr.right = mr.left + Req + ( wr.right - wr.left ) - ( cr.right - cr.left );

	int haba = GetSystemMetrics(SM_CXSCREEN);

	WINDOWPLACEMENT plc;
	GetParent()->GetWindowPlacement(&plc);
	if( haba < mr.right - mr.left )
	{
		plc.showCmd = SW_SHOWMAXIMIZED;
	}
	else
	{
		plc.showCmd = SW_SHOWNORMAL;
		plc.rcNormalPosition = mr;
	}
	GetParent()->SetWindowPlacement(&plc);
}

void CTextSmileView::OnViewAutoresize() 
{
	m_bAutoRS = !m_bAutoRS;
	FitWindow();
}

void CTextSmileView::OnUpdateViewAutoresize(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bAutoRS);
}

void CTextSmileView::OnDropFiles(HDROP hDropInfo) 
{
	char str[256];
	int num = DragQueryFile(hDropInfo,0xffffffff,str,256);
	AfxGetMainWnd()->SetWindowPos(&wndTop,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	if( num==0 )
		return;

	char ThisExe[MAX_PATH];
	GetModuleFileName(NULL,ThisExe,sizeof(ThisExe));

	// Pڂ͎ŊJ
	DragQueryFile(hDropInfo,0,str,256);
	if( GetDocument()->OnOpenDocument(str) )
		GetDocument()->SetPathName(str);
	// ͑։
	for( int i=1; i!=num; i++ )
	{
		DragQueryFile(hDropInfo,i,str,256);
		ShellExecute( AfxGetMainWnd()->GetSafeHwnd(),"open",ThisExe,str,NULL,SW_SHOWDEFAULT );
	}
}

void CTextSmileView::OnInitialUpdate() 
{
	CEditView::OnInitialUpdate();

	if( !GetDocument()->m_bInit )
	{
		GetDocument()->m_bInit = true;
		CString str=GetDocument()->GetPathName();
		if( !str.IsEmpty() )
			GetDocument()->OnOpenDocument( str );
		GetEditCtrl().SetReadOnly(TRUE);
		GetEditCtrl().SetFont(&m_Font,TRUE);
	}
	DragAcceptFiles();
}

void CTextSmileView::OnMinimize() 
{
	WINDOWPLACEMENT plc;
	GetParent()->GetWindowPlacement(&plc);
	plc.showCmd = SW_SHOWMINIMIZED;
	GetParent()->SetWindowPlacement(&plc);
}
